#pragma once

#include <QObject>

#include <QProcess>

class Command : public QObject
{
    Q_OBJECT
public:
    explicit Command(QObject *parent = nullptr);
    virtual ~Command();

    QString get() const;
    void set(QString command);
    void setTimeout(int seconds);

    bool syncExecute();

    int exitCode() const;
    QByteArray output() const;
    QByteArray error() const;

signals:

private:
    void clear();
    QString commandString() const;

    QString m_command;
    int m_timeout;
    int m_exitCode;
    QByteArray m_output;
    QByteArray m_error;

    QString m_shell;
    QStringList m_commandLine;
    QProcess *p_process;
};
