#pragma once

#include <QObject>
#include <QThread>
#include <QTimer>

#include "Command.hpp"
#include "Worker.hpp"

class MainQ : public QObject
{
    Q_OBJECT
public:
    explicit MainQ(QObject *parent = nullptr);
    virtual ~MainQ();

signals:
    void runWorkerCommand(QString command);

private slots:
    void directSyncCommand();
    void handleWorkerReply(QString reply);

private:
    Command *p_command;
    QTimer *p_commandTimer;

    Worker *p_worker;
    QThread *p_workerThread;
    QTimer *p_workerTimer;
};
