#include <QDebug>

#include "Worker.hpp"

Worker::Worker(QObject *parent) : QObject(parent)
{
    p_command = new Command(this);
    p_command->setTimeout(5); //5 seconds
}

Worker::~Worker()
{
    if (p_command) {
        p_command->deleteLater();
    }
}

void Worker::setNowCommand(QString nowCommand)
{
    m_nowCommand = nowCommand;
}

void Worker::runCommand(QString command)
{
    qDebug() << __func__;
    m_reply.clear();
    p_command->set(command);

    if (p_command->syncExecute()) {
        m_reply.append(QString(p_command->output().trimmed()));
    }
    else {
        qWarning() << "syncExecute error" << p_command->error().trimmed()
                   << "in command" << p_command->get().trimmed();
        return;
    }

    p_command->set(m_nowCommand);

    if (p_command->syncExecute()) {
        m_reply.append("\r\n");
        m_reply.append(QString(p_command->output().trimmed()));
    }
    else {
        qWarning() << "syncExecute error" << p_command->error().trimmed()
                   << "in command" << p_command->get().trimmed();
        return;
    }

    emit replyReady(m_reply);
}
